BdbService.Iface (Oracle - Berkeley DB Client-Server API)
Date: 2018-05-29

com.sleepycat.thrift

## Interface BdbService.Iface

- All Known Implementing Classes:
    BdbService.Client
  Enclosing class:
    BdbService

      public static interface BdbService.Iface

  *********************** Service Definitions * ***********************

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `TTransaction` | `beginTransaction(TEnvironment env, TTransaction parent, TTransactionConfig config)`
    `void` | `checkpoint(TEnvironment env, int kbytes, int min, boolean force)`
    `void` | `closeCursorHandle(TCursor cursor)`
    `void` | `closeDatabaseHandle(TDatabase db)`
    `void` | `closeDatabaseHandles(java.lang.String envHomeDir, java.lang.String fileName, java.lang.String databaseName, long minIdleInMilli)`
    `void` | `closeEnvironmentHandle(TEnvironment env)`
    `void` | `closeEnvironmentHandles(java.lang.String homeDir, long minIdleInMilli)`
    `void` | `closeJoinCursorHandle(TJoinCursor cursor)`
    `void` | `closeSequenceHandle(TSequence seq)`
    `short` | `cursorCompare(TCursor cursor1, TCursor cursor2)`
    `int` | `cursorCount(TCursor cursor)`
    `TOperationStatus` | `cursorDelete(TCursor cursor)`
    `TCursor` | `cursorDup(TCursor cursor, boolean samePos)`
    `TGetResult` | `cursorGet(TCursor cursor, TKeyData keyData, TCursorGetConfig config)`
    `TGetWithPKeyResult` | `cursorGetWithPKey(TCursor cursor, TKeyDataWithPKey keyPKey, TCursorGetConfig config)`
    `TPutResult` | `cursorPut(TCursor cursor, TKeyDataWithSecondaryKeys pair, TCursorPutConfig config)`
    `TCompactResult` | `dbCompact(TDatabase db, TTransaction txn, TDbt start, TDbt stop, TCompactConfig config)`
    `TOperationStatus` | `dbDelete(TDatabase db, TTransaction txn, java.util.List<TKeyData> keyOrPairs)`
    `TGetResult` | `dbGet(TDatabase db, TTransaction txn, TKeyData keyData, TDbGetConfig config)`
    `TGetWithPKeyResult` | `dbGetWithPKey(TDatabase sdb, TTransaction txn, TKeyDataWithPKey keyPKey, TDbGetConfig config)`
    `TOperationStatus` | `dbKeyExists(TDatabase db, TTransaction txn, TDbt key)`
    `TKeyRangeResult` | `dbKeyRange(TDatabase db, TTransaction txn, TDbt key)`
    `TPutResult` | `dbPut(TDatabase db, TTransaction txn, java.util.List<TKeyDataWithSecondaryKeys> pairs, TDbPutConfig config)`
    `int` | `dbTruncate(TDatabase db, TTransaction txn, boolean countRecords)`
    `void` | `deleteEnvironmentAndDatabases(java.lang.String homeDir, boolean force)`
    `java.lang.String` | `getBdbVersion()`
    `TCachePriority` | `getCursorCachePriority(TCursor cursor)`
    `TCursorConfig` | `getCursorConfig(TCursor cursor)`
    `TDatabaseConfig` | `getDatabaseConfig(TDatabase db)`
    `TDatabaseStatResult` | `getDatabaseStatistics(TDatabase db, TTransaction txn, boolean fast)`
    `TEnvironmentConfig` | `getEnvironmentConfig(TEnvironment env)`
    `TEnvStatResult` | `getEnvStatistics(TEnvironment env, TEnvStatConfig config)`
    `TProtocolVersionTestResult` | `isProtocolVersionSupported(java.lang.String clientVersion)`
    `TGetResult` | `joinCursorGet(TJoinCursor cursor, TJoinCursorGetConfig config)`
    `TCursor` | `openCursor(TDatabase db, TTransaction txn, TCursorConfig cursorConfig)`
    `TDatabase` | `openDatabase(TEnvironment env, TTransaction txn, java.lang.String fileName, java.lang.String databaseName, TDatabaseConfig dbConfig)`
    `TEnvironment` | `openEnvironment(java.lang.String homeDir, TEnvironmentConfig envConfig)`
    `TJoinCursor` | `openJoinCursor(TDatabase pdb, java.util.List<TCursor> scursors, boolean sortCursors)`
    `TDatabase` | `openSecondaryDatabase(TEnvironment env, TTransaction txn, java.lang.String fileName, java.lang.String databaseName, TDatabase primaryDb, TSecondaryDatabaseConfig sdbConfig)`
    `TSequence` | `openSequence(TDatabase db, TTransaction txn, TDbt key, TSequenceConfig config)`
    `void` | `ping()`
    `void` | `removeDatabase(TEnvironment env, TTransaction txn, java.lang.String fileName, java.lang.String databaseName, boolean force)`
    `void` | `removeSequence(TDatabase db, TTransaction txn, TDbt key, boolean isAutoCommitNoSync, boolean force)`
    `void` | `renameDatabase(TEnvironment env, TTransaction txn, java.lang.String fileName, java.lang.String databaseName, java.lang.String newName, boolean force)`
    `long` | `sequenceGet(TSequence seq, TTransaction txn, int delta)`
    `void` | `setCursorCachePriority(TCursor cursor, TCachePriority priority)`
    `void` | `setDatabaseConfig(TDatabase db, TDatabaseConfig dbConfig)`
    `void` | `setEnvironmentConfig(TEnvironment env, TEnvironmentConfig envConfig)`
    `void` | `shutdown()`
    `void` | `txnAbort(TTransaction txn)`
    `void` | `txnCommit(TTransaction txn, TDurabilityPolicy durability)`
    `int` | `txnGetPriority(TTransaction txn)`
    `void` | `txnSetPriority(TTransaction txn, int priority)`

- - ### Method Detail

    - #### ping

          void ping()
             throws org.apache.thrift.TException

      Throws:
        `org.apache.thrift.TException`

    - #### isProtocolVersionSupported

          TProtocolVersionTestResult isProtocolVersionSupported(java.lang.String clientVersion)
                                                         throws org.apache.thrift.TException

      Throws:
        `org.apache.thrift.TException`

    - #### getBdbVersion

          java.lang.String getBdbVersion()
                                  throws org.apache.thrift.TException

      Throws:
        `org.apache.thrift.TException`

    - #### shutdown

          void shutdown()
                 throws org.apache.thrift.TException

      Throws:
        `org.apache.thrift.TException`

    - #### openEnvironment

          TEnvironment openEnvironment(java.lang.String homeDir,
                                       TEnvironmentConfig envConfig)
                                throws TIOException,
                                       TResourceInUseException,
                                       TDatabaseException,
                                       TRuntimeException,
                                       org.apache.thrift.TException

      Throws:
        `TIOException`
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### closeEnvironmentHandle

          void closeEnvironmentHandle(TEnvironment env)
                               throws TDatabaseException,
                                      TRuntimeException,
                                      org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### closeEnvironmentHandles

          void closeEnvironmentHandles(java.lang.String homeDir,
                                       long minIdleInMilli)
                                throws TDatabaseException,
                                       TRuntimeException,
                                       org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### deleteEnvironmentAndDatabases

          void deleteEnvironmentAndDatabases(java.lang.String homeDir,
                                             boolean force)
                                      throws TFileNotFoundException,
                                             TIOException,
                                             TResourceInUseException,
                                             TDatabaseException,
                                             TRuntimeException,
                                             org.apache.thrift.TException

      Throws:
        `TFileNotFoundException`
        `TIOException`
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### getEnvironmentConfig

          TEnvironmentConfig getEnvironmentConfig(TEnvironment env)
                                           throws TDatabaseException,
                                                  TRuntimeException,
                                                  org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### setEnvironmentConfig

          void setEnvironmentConfig(TEnvironment env,
                                    TEnvironmentConfig envConfig)
                             throws TDatabaseException,
                                    TRuntimeException,
                                    org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### removeDatabase

          void removeDatabase(TEnvironment env,
                              TTransaction txn,
                              java.lang.String fileName,
                              java.lang.String databaseName,
                              boolean force)
                       throws TIOException,
                              TResourceInUseException,
                              TDatabaseException,
                              TRuntimeException,
                              org.apache.thrift.TException

      Throws:
        `TIOException`
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### renameDatabase

          void renameDatabase(TEnvironment env,
                              TTransaction txn,
                              java.lang.String fileName,
                              java.lang.String databaseName,
                              java.lang.String newName,
                              boolean force)
                       throws TIOException,
                              TResourceInUseException,
                              TDatabaseException,
                              TRuntimeException,
                              org.apache.thrift.TException

      Throws:
        `TIOException`
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### checkpoint

          void checkpoint(TEnvironment env,
                          int kbytes,
                          int min,
                          boolean force)
                   throws TDatabaseException,
                          TRuntimeException,
                          org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### openDatabase

          TDatabase openDatabase(TEnvironment env,
                                 TTransaction txn,
                                 java.lang.String fileName,
                                 java.lang.String databaseName,
                                 TDatabaseConfig dbConfig)
                          throws TIOException,
                                 TResourceInUseException,
                                 TDatabaseException,
                                 TRuntimeException,
                                 org.apache.thrift.TException

      Throws:
        `TIOException`
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### openSecondaryDatabase

          TDatabase openSecondaryDatabase(TEnvironment env,
                                          TTransaction txn,
                                          java.lang.String fileName,
                                          java.lang.String databaseName,
                                          TDatabase primaryDb,
                                          TSecondaryDatabaseConfig sdbConfig)
                                   throws TIOException,
                                          TResourceInUseException,
                                          TDatabaseException,
                                          TRuntimeException,
                                          org.apache.thrift.TException

      Throws:
        `TIOException`
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### closeDatabaseHandle

          void closeDatabaseHandle(TDatabase db)
                            throws TDatabaseException,
                                   TRuntimeException,
                                   org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### closeDatabaseHandles

          void closeDatabaseHandles(java.lang.String envHomeDir,
                                    java.lang.String fileName,
                                    java.lang.String databaseName,
                                    long minIdleInMilli)
                             throws TDatabaseException,
                                    TRuntimeException,
                                    org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### getDatabaseConfig

          TDatabaseConfig getDatabaseConfig(TDatabase db)
                                     throws TDatabaseException,
                                            TRuntimeException,
                                            org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### setDatabaseConfig

          void setDatabaseConfig(TDatabase db,
                                 TDatabaseConfig dbConfig)
                          throws TDatabaseException,
                                 TRuntimeException,
                                 org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbGet

          TGetResult dbGet(TDatabase db,
                           TTransaction txn,
                           TKeyData keyData,
                           TDbGetConfig config)
                    throws TDatabaseException,
                           TRuntimeException,
                           org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbGetWithPKey

          TGetWithPKeyResult dbGetWithPKey(TDatabase sdb,
                                           TTransaction txn,
                                           TKeyDataWithPKey keyPKey,
                                           TDbGetConfig config)
                                    throws TDatabaseException,
                                           TRuntimeException,
                                           org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbPut

          TPutResult dbPut(TDatabase db,
                           TTransaction txn,
                           java.util.List<TKeyDataWithSecondaryKeys> pairs,
                           TDbPutConfig config)
                    throws TDatabaseException,
                           TRuntimeException,
                           org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbDelete

          TOperationStatus dbDelete(TDatabase db,
                                    TTransaction txn,
                                    java.util.List<TKeyData> keyOrPairs)
                             throws TDatabaseException,
                                    TRuntimeException,
                                    org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbKeyExists

          TOperationStatus dbKeyExists(TDatabase db,
                                       TTransaction txn,
                                       TDbt key)
                                throws TDatabaseException,
                                       TRuntimeException,
                                       org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbKeyRange

          TKeyRangeResult dbKeyRange(TDatabase db,
                                     TTransaction txn,
                                     TDbt key)
                              throws TDatabaseException,
                                     TRuntimeException,
                                     org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbCompact

          TCompactResult dbCompact(TDatabase db,
                                   TTransaction txn,
                                   TDbt start,
                                   TDbt stop,
                                   TCompactConfig config)
                            throws TDatabaseException,
                                   TRuntimeException,
                                   org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### dbTruncate

          int dbTruncate(TDatabase db,
                         TTransaction txn,
                         boolean countRecords)
                  throws TDatabaseException,
                         TRuntimeException,
                         org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### openCursor

          TCursor openCursor(TDatabase db,
                             TTransaction txn,
                             TCursorConfig cursorConfig)
                      throws TDatabaseException,
                             TRuntimeException,
                             org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### closeCursorHandle

          void closeCursorHandle(TCursor cursor)
                          throws TDatabaseException,
                                 TRuntimeException,
                                 org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### getCursorConfig

          TCursorConfig getCursorConfig(TCursor cursor)
                                 throws TDatabaseException,
                                        TRuntimeException,
                                        org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### getCursorCachePriority

          TCachePriority getCursorCachePriority(TCursor cursor)
                                         throws TDatabaseException,
                                                TRuntimeException,
                                                org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### setCursorCachePriority

          void setCursorCachePriority(TCursor cursor,
                                      TCachePriority priority)
                               throws TDatabaseException,
                                      TRuntimeException,
                                      org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### cursorGet

          TGetResult cursorGet(TCursor cursor,
                               TKeyData keyData,
                               TCursorGetConfig config)
                        throws TDatabaseException,
                               TRuntimeException,
                               org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### cursorGetWithPKey

          TGetWithPKeyResult cursorGetWithPKey(TCursor cursor,
                                               TKeyDataWithPKey keyPKey,
                                               TCursorGetConfig config)
                                        throws TDatabaseException,
                                               TRuntimeException,
                                               org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### cursorPut

          TPutResult cursorPut(TCursor cursor,
                               TKeyDataWithSecondaryKeys pair,
                               TCursorPutConfig config)
                        throws TDatabaseException,
                               TRuntimeException,
                               org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### cursorDelete

          TOperationStatus cursorDelete(TCursor cursor)
                                 throws TDatabaseException,
                                        TRuntimeException,
                                        org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### cursorDup

          TCursor cursorDup(TCursor cursor,
                            boolean samePos)
                     throws TDatabaseException,
                            TRuntimeException,
                            org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### cursorCompare

          short cursorCompare(TCursor cursor1,
                              TCursor cursor2)
                       throws TDatabaseException,
                              TRuntimeException,
                              org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### cursorCount

          int cursorCount(TCursor cursor)
                   throws TDatabaseException,
                          TRuntimeException,
                          org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### openJoinCursor

          TJoinCursor openJoinCursor(TDatabase pdb,
                                     java.util.List<TCursor> scursors,
                                     boolean sortCursors)
                              throws TDatabaseException,
                                     TRuntimeException,
                                     org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### closeJoinCursorHandle

          void closeJoinCursorHandle(TJoinCursor cursor)
                              throws TDatabaseException,
                                     TRuntimeException,
                                     org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### joinCursorGet

          TGetResult joinCursorGet(TJoinCursor cursor,
                                   TJoinCursorGetConfig config)
                            throws TDatabaseException,
                                   TRuntimeException,
                                   org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### beginTransaction

          TTransaction beginTransaction(TEnvironment env,
                                        TTransaction parent,
                                        TTransactionConfig config)
                                 throws TDatabaseException,
                                        TRuntimeException,
                                        org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### txnAbort

          void txnAbort(TTransaction txn)
                 throws TDatabaseException,
                        TRuntimeException,
                        org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### txnCommit

          void txnCommit(TTransaction txn,
                         TDurabilityPolicy durability)
                  throws TDatabaseException,
                         TRuntimeException,
                         org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### txnGetPriority

          int txnGetPriority(TTransaction txn)
                      throws TDatabaseException,
                             TRuntimeException,
                             org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### txnSetPriority

          void txnSetPriority(TTransaction txn,
                              int priority)
                       throws TDatabaseException,
                              TRuntimeException,
                              org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### openSequence

          TSequence openSequence(TDatabase db,
                                 TTransaction txn,
                                 TDbt key,
                                 TSequenceConfig config)
                          throws TResourceInUseException,
                                 TDatabaseException,
                                 TRuntimeException,
                                 org.apache.thrift.TException

      Throws:
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### closeSequenceHandle

          void closeSequenceHandle(TSequence seq)
                            throws TDatabaseException,
                                   TRuntimeException,
                                   org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### removeSequence

          void removeSequence(TDatabase db,
                              TTransaction txn,
                              TDbt key,
                              boolean isAutoCommitNoSync,
                              boolean force)
                       throws TResourceInUseException,
                              TDatabaseException,
                              TRuntimeException,
                              org.apache.thrift.TException

      Throws:
        `TResourceInUseException`
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### sequenceGet

          long sequenceGet(TSequence seq,
                           TTransaction txn,
                           int delta)
                    throws TDatabaseException,
                           TRuntimeException,
                           org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### getEnvStatistics

          TEnvStatResult getEnvStatistics(TEnvironment env,
                                          TEnvStatConfig config)
                                   throws TDatabaseException,
                                          TRuntimeException,
                                          org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

    - #### getDatabaseStatistics

          TDatabaseStatResult getDatabaseStatistics(TDatabase db,
                                                    TTransaction txn,
                                                    boolean fast)
                                             throws TDatabaseException,
                                                    TRuntimeException,
                                                    org.apache.thrift.TException

      Throws:
        `TDatabaseException`
        `TRuntimeException`
        `org.apache.thrift.TException`

Copyright (c) 2016, 2018 Oracle and/or its affiliates. All rights reserved.